# forestvpn_auth_api
ForestVPN defeats content restrictions and censorship to deliver unlimited access to video, music, social media, 
and more, from anywhere in the world.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://www.forestvpn.com/](https://www.forestvpn.com/)

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_auth_api:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_auth_api:
    path: /path/to/forestvpn_auth_api
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:forestvpn_auth_api/api.dart';

// TODO Configure API key authorization: Bearer
//defaultApiClient.getAuthentication<ApiKeyAuth>('Bearer').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('Bearer').apiKeyPrefix = 'Bearer';

final api_instance = AuthApi();
final request = IntrospectionRequest(); // IntrospectionRequest | 

try {
    final result = api_instance.introspect(request);
    print(result);
} catch (e) {
    print('Exception when calling AuthApi->introspect: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *https://auth.forestvpn.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthApi* | [**introspect**](doc//AuthApi.md#introspect) | **POST** /introspect/ | Token introspection
*AuthApi* | [**login**](doc//AuthApi.md#login) | **POST** /login/ | Login
*AuthApi* | [**profileGet**](doc//AuthApi.md#profileget) | **GET** /profile/ | Get authenticated user's profile
*AuthApi* | [**refreshToken**](doc//AuthApi.md#refreshtoken) | **POST** /token/ | Refresh access token
*AuthApi* | [**registrationSessionCreate**](doc//AuthApi.md#registrationsessioncreate) | **POST** /registration/ | Create user registration session
*AuthApi* | [**registrationSessionValidate**](doc//AuthApi.md#registrationsessionvalidate) | **PUT** /registration/{sessionId}/validate/ | Send email validation message
*AuthApi* | [**registrationSessionVerify**](doc//AuthApi.md#registrationsessionverify) | **PUT** /registration/{sessionId}/verify/ | Verify email address
*AuthApi* | [**signIn**](doc//AuthApi.md#signin) | **POST** /signin/ | Sign In
*AuthApi* | [**signInResend**](doc//AuthApi.md#signinresend) | **POST** /signin/{sessionId}/resend/ | Resend OTP for Sign In
*AuthApi* | [**signInVerify**](doc//AuthApi.md#signinverify) | **POST** /signin/{sessionId}/verify/ | One time code verification
*AuthApi* | [**signUp**](doc//AuthApi.md#signup) | **POST** /signup/ | Sign Up
*AuthApi* | [**signUpResend**](doc//AuthApi.md#signupresend) | **POST** /signup/{sessionId}/resend/ | Resend OTP for Sign Up
*AuthApi* | [**signUpVerify**](doc//AuthApi.md#signupverify) | **POST** /signup/{sessionId}/verify/ | Sign Up verification


## Documentation For Models

 - [Error](doc//Error.md)
 - [IntrospectionRequest](doc//IntrospectionRequest.md)
 - [IntrospectionResponse](doc//IntrospectionResponse.md)
 - [IntrospectionResponseExt](doc//IntrospectionResponseExt.md)
 - [SignInRequest](doc//SignInRequest.md)
 - [SignInResponse](doc//SignInResponse.md)
 - [SignInVerifyRequest](doc//SignInVerifyRequest.md)
 - [SignUpRequest](doc//SignUpRequest.md)
 - [SignUpResponse](doc//SignUpResponse.md)
 - [SignUpVerifyRequest](doc//SignUpVerifyRequest.md)
 - [TokenRequest](doc//TokenRequest.md)
 - [TokenResponse](doc//TokenResponse.md)
 - [UserLoginRequest](doc//UserLoginRequest.md)
 - [UserProfile](doc//UserProfile.md)
 - [UserRegistrationRequest](doc//UserRegistrationRequest.md)
 - [UserRegistrationResponse](doc//UserRegistrationResponse.md)
 - [UserRegistrationVerifyRequest](doc//UserRegistrationVerifyRequest.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

support@forestvpn.com


