# forestvpn_auth_api.model.IntrospectionResponse

## Load the model package
```dart
import 'package:forestvpn_auth_api/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**active** | **bool** | Boolean indicator of whether or not the presented token is currently active. | 
**aud** | **List<String>** | Service-specific string identifier or list of string identifiers representing the intended audience for this token, as defined in JWT | [optional] [default to const []]
**clientId** | **String** | Client identifier for the OAuth 2.0 client that requested this token. | [optional] 
**exp** | **int** | Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token will expire, as defined in JWT | [optional] 
**ext** | [**IntrospectionResponseExt**](IntrospectionResponseExt.md) |  | [optional] 
**iat** | **int** | Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token was originally issued, as defined in JWT | [optional] 
**iss** | **String** | String representing the issuer of this token, as defined in JWT | [optional] 
**nbf** | **int** | Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token is not to be used before, as defined in JWT | [optional] 
**tokenType** | **String** |  | [optional] 
**username** | **String** | Human-readable identifier for the resource owner who authorized this token. | [optional] 
**sub** | **String** | Subject of the token, as defined in JWT. Usually a machine-readable identifier of the resource owner who authorized this token. | [optional] 
**jti** | **String** | String identifier for the token, as defined in JWT | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


