//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class AuthApi {
  AuthApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Token introspection
  ///
  /// The introspection endpoint allows to check if a token (both refresh and access) is active or not.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [IntrospectionRequest] request (required):
  Future<Response> introspectWithHttpInfo(IntrospectionRequest request) async {
    // Verify required params are set.
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/introspect/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Token introspection
  ///
  /// The introspection endpoint allows to check if a token (both refresh and access) is active or not.
  ///
  /// Parameters:
  ///
  /// * [IntrospectionRequest] request (required):
  Future<IntrospectionResponse?> introspect(IntrospectionRequest request) async {
    final response = await introspectWithHttpInfo(request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'IntrospectionResponse',
      ) as IntrospectionResponse?;
    }
    return Future<IntrospectionResponse>.value(null);
  }

  /// Login
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [UserLoginRequest] request (required):
  Future<Response> loginWithHttpInfo(UserLoginRequest request) async {
    // Verify required params are set.
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/login/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Login
  ///
  /// Parameters:
  ///
  /// * [UserLoginRequest] request (required):
  Future<TokenResponse?> login(UserLoginRequest request) async {
    final response = await loginWithHttpInfo(request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'TokenResponse',
      ) as TokenResponse?;
    }
    return Future<TokenResponse>.value(null);
  }

  /// Get authenticated user's profile
  ///
  /// Note: This method returns the HTTP [Response].
  Future<Response> profileGetWithHttpInfo() async {
    final path = r'/profile/';

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Get authenticated user's profile
  Future<UserProfile?> profileGet() async {
    final response = await profileGetWithHttpInfo();
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'UserProfile',
      ) as UserProfile?;
    }
    return Future<UserProfile>.value(null);
  }

  /// Refresh access token
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [TokenRequest] request (required):
  Future<Response> refreshTokenWithHttpInfo(TokenRequest request) async {
    // Verify required params are set.
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/token/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Refresh access token
  ///
  /// Parameters:
  ///
  /// * [TokenRequest] request (required):
  Future<TokenResponse?> refreshToken(TokenRequest request) async {
    final response = await refreshTokenWithHttpInfo(request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'TokenResponse',
      ) as TokenResponse?;
    }
    return Future<TokenResponse>.value(null);
  }

  /// Create user registration session
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [UserRegistrationRequest] request (required):
  Future<Response> registrationSessionCreateWithHttpInfo(UserRegistrationRequest request) async {
    // Verify required params are set.
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/registration/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Create user registration session
  ///
  /// Parameters:
  ///
  /// * [UserRegistrationRequest] request (required):
  Future<UserRegistrationResponse?> registrationSessionCreate(
      UserRegistrationRequest request) async {
    final response = await registrationSessionCreateWithHttpInfo(request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'UserRegistrationResponse',
      ) as UserRegistrationResponse?;
    }
    return Future<UserRegistrationResponse>.value(null);
  }

  /// Send email validation message
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Registration Session ID
  Future<Response> registrationSessionValidateWithHttpInfo(String sessionId) async {
    // Verify required params are set.
    if (sessionId == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: sessionId');
    }

    final path = r'/registration/{sessionId}/validate/'
        .replaceAll('{' + 'sessionId' + '}', sessionId.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Send email validation message
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Registration Session ID
  Future<void> registrationSessionValidate(String sessionId) async {
    final response = await registrationSessionValidateWithHttpInfo(sessionId);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Verify email address
  ///
  /// Verify email address
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Registration Session ID
  ///
  /// * [UserRegistrationVerifyRequest] verifyRequest (required):
  Future<Response> registrationSessionVerifyWithHttpInfo(
      String sessionId, UserRegistrationVerifyRequest verifyRequest) async {
    // Verify required params are set.
    if (sessionId == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: sessionId');
    }
    if (verifyRequest == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: verifyRequest');
    }

    final path = r'/registration/{sessionId}/verify/'
        .replaceAll('{' + 'sessionId' + '}', sessionId.toString());

    Object postBody = verifyRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Verify email address
  ///
  /// Verify email address
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Registration Session ID
  ///
  /// * [UserRegistrationVerifyRequest] verifyRequest (required):
  Future<TokenResponse?> registrationSessionVerify(
      String sessionId, UserRegistrationVerifyRequest verifyRequest) async {
    final response = await registrationSessionVerifyWithHttpInfo(sessionId, verifyRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'TokenResponse',
      ) as TokenResponse?;
    }
    return Future<TokenResponse>.value(null);
  }

  /// Sign In
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [SignInRequest] request (required):
  Future<Response> signInWithHttpInfo(SignInRequest request) async {
    // Verify required params are set.
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/signin/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Sign In
  ///
  /// Parameters:
  ///
  /// * [SignInRequest] request (required):
  Future<SignInResponse?> signIn(SignInRequest request) async {
    final response = await signInWithHttpInfo(request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'SignInResponse',
      ) as SignInResponse?;
    }
    return Future<SignInResponse>.value(null);
  }

  /// Resend OTP for Sign In
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign In Session ID
  Future<Response> signInResendWithHttpInfo(String sessionId) async {
    // Verify required params are set.
    if (sessionId == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: sessionId');
    }

    final path =
        r'/signin/{sessionId}/resend/'.replaceAll('{' + 'sessionId' + '}', sessionId.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Resend OTP for Sign In
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign In Session ID
  Future<void> signInResend(String sessionId) async {
    final response = await signInResendWithHttpInfo(sessionId);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// One time code verification
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign In Session ID
  ///
  /// * [SignInVerifyRequest] request (required):
  Future<Response> signInVerifyWithHttpInfo(String sessionId, SignInVerifyRequest request) async {
    // Verify required params are set.
    if (sessionId == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: sessionId');
    }
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path =
        r'/signin/{sessionId}/verify/'.replaceAll('{' + 'sessionId' + '}', sessionId.toString());

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// One time code verification
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign In Session ID
  ///
  /// * [SignInVerifyRequest] request (required):
  Future<TokenResponse?> signInVerify(String sessionId, SignInVerifyRequest request) async {
    final response = await signInVerifyWithHttpInfo(sessionId, request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'TokenResponse',
      ) as TokenResponse?;
    }
    return Future<TokenResponse>.value(null);
  }

  /// Sign Up
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [SignUpRequest] request (required):
  Future<Response> signUpWithHttpInfo(SignUpRequest request) async {
    // Verify required params are set.
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/signup/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Sign Up
  ///
  /// Parameters:
  ///
  /// * [SignUpRequest] request (required):
  Future<SignUpResponse?> signUp(SignUpRequest request) async {
    final response = await signUpWithHttpInfo(request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'SignUpResponse',
      ) as SignUpResponse?;
    }
    return Future<SignUpResponse>.value(null);
  }

  /// Resend OTP for Sign Up
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign In Session ID
  Future<Response> signUpResendWithHttpInfo(String sessionId) async {
    // Verify required params are set.
    if (sessionId == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: sessionId');
    }

    final path =
        r'/signup/{sessionId}/resend/'.replaceAll('{' + 'sessionId' + '}', sessionId.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Resend OTP for Sign Up
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign In Session ID
  Future<void> signUpResend(String sessionId) async {
    final response = await signUpResendWithHttpInfo(sessionId);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Sign Up verification
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign Up Session ID
  ///
  /// * [SignUpVerifyRequest] request (required):
  Future<Response> signUpVerifyWithHttpInfo(String sessionId, SignUpVerifyRequest request) async {
    // Verify required params are set.
    if (sessionId == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: sessionId');
    }
    if (request == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path =
        r'/signup/{sessionId}/verify/'.replaceAll('{' + 'sessionId' + '}', sessionId.toString());

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Sign Up verification
  ///
  /// Parameters:
  ///
  /// * [String] sessionId (required):
  ///   Sign Up Session ID
  ///
  /// * [SignUpVerifyRequest] request (required):
  Future<TokenResponse?> signUpVerify(String sessionId, SignUpVerifyRequest request) async {
    final response = await signUpVerifyWithHttpInfo(sessionId, request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'TokenResponse',
      ) as TokenResponse?;
    }
    return Future<TokenResponse>.value(null);
  }
}
