//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//


// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class IntrospectionResponse {
  /// Returns a new [IntrospectionResponse] instance.
  IntrospectionResponse({
    required this.active,
    this.aud = const [],
    this.clientId,
    this.exp,
    this.ext,
    this.iat,
    this.iss,
    this.nbf,
    this.tokenType,
    this.username,
    this.sub,
    this.jti,
  });

  /// Boolean indicator of whether or not the presented token is currently active.
  bool? active;

  /// Service-specific string identifier or list of string identifiers representing the intended audience for this token, as defined in JWT
  List<String>? aud;

  /// Client identifier for the OAuth 2.0 client that requested this token.
  String? clientId;

  /// Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token will expire, as defined in JWT
  int? exp;

  IntrospectionResponseExt? ext;

  /// Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token was originally issued, as defined in JWT
  int? iat;

  /// String representing the issuer of this token, as defined in JWT
  String? iss;

  /// Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token is not to be used before, as defined in JWT
  int? nbf;

  String? tokenType;

  /// Human-readable identifier for the resource owner who authorized this token.
  String? username;

  /// Subject of the token, as defined in JWT. Usually a machine-readable identifier of the resource owner who authorized this token.
  String? sub;

  /// String identifier for the token, as defined in JWT
  String? jti;

  @override
  bool operator ==(Object other) => identical(this, other) || other is IntrospectionResponse &&
     other.active == active &&
     other.aud == aud &&
     other.clientId == clientId &&
     other.exp == exp &&
     other.ext == ext &&
     other.iat == iat &&
     other.iss == iss &&
     other.nbf == nbf &&
     other.tokenType == tokenType &&
     other.username == username &&
     other.sub == sub &&
     other.jti == jti;

  @override
  int get hashCode =>
    (active == null ? 0 : active.hashCode) +
    (aud == null ? 0 : aud.hashCode) +
    (clientId == null ? 0 : clientId.hashCode) +
    (exp == null ? 0 : exp.hashCode) +
    (ext == null ? 0 : ext.hashCode) +
    (iat == null ? 0 : iat.hashCode) +
    (iss == null ? 0 : iss.hashCode) +
    (nbf == null ? 0 : nbf.hashCode) +
    (tokenType == null ? 0 : tokenType.hashCode) +
    (username == null ? 0 : username.hashCode) +
    (sub == null ? 0 : sub.hashCode) +
    (jti == null ? 0 : jti.hashCode);

  @override
  String toString() => 'IntrospectionResponse[active=$active, aud=$aud, clientId=$clientId, exp=$exp, ext=$ext, iat=$iat, iss=$iss, nbf=$nbf, tokenType=$tokenType, username=$username, sub=$sub, jti=$jti]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
      json[r'active'] = active;
    if (aud != null) {
      json[r'aud'] = aud;
    }
    if (clientId != null) {
      json[r'client_id'] = clientId;
    }
    if (exp != null) {
      json[r'exp'] = exp;
    }
    if (ext != null) {
      json[r'ext'] = ext;
    }
    if (iat != null) {
      json[r'iat'] = iat;
    }
    if (iss != null) {
      json[r'iss'] = iss;
    }
    if (nbf != null) {
      json[r'nbf'] = nbf;
    }
    if (tokenType != null) {
      json[r'token_type'] = tokenType;
    }
    if (username != null) {
      json[r'username'] = username;
    }
    if (sub != null) {
      json[r'sub'] = sub;
    }
    if (jti != null) {
      json[r'jti'] = jti;
    }
    return json;
  }

  /// Returns a new [IntrospectionResponse] instance and imports its values from
  /// [json] if it's non-null, null if [json] is null.
  static IntrospectionResponse? fromJson(Map<String, dynamic>? json) => json == null
    ? null
    : IntrospectionResponse(
        active: json[r'active'],
        aud: json[r'aud'] == null
          ? null
          : (json[r'aud'] as List).cast<String>(),
        clientId: json[r'client_id'],
        exp: json[r'exp'],
        ext: IntrospectionResponseExt.fromJson(json[r'ext']),
        iat: json[r'iat'],
        iss: json[r'iss'],
        nbf: json[r'nbf'],
        tokenType: json[r'token_type'],
        username: json[r'username'],
        sub: json[r'sub'],
        jti: json[r'jti'],
    );

  static List<IntrospectionResponse?>? listFromJson(List<dynamic> json, {bool? emptyIsNull, bool? growable,}) =>
    json == null || json.isEmpty
      ? true == emptyIsNull ? null : <IntrospectionResponse>[]
      : json.map((v) => IntrospectionResponse.fromJson(v)).toList(growable: true == growable);

  static Map<String, IntrospectionResponse?> mapFromJson(Map<String, dynamic> json) {
    final map = <String, IntrospectionResponse?>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic v) => map[key] = IntrospectionResponse.fromJson(v));
    }
    return map;
  }

  // maps a json object with a list of IntrospectionResponse-objects as value to a dart map
  static Map<String, List<IntrospectionResponse?>?> mapListFromJson(Map<String, dynamic> json, {bool? emptyIsNull, bool? growable,}) {
    final Map<String, List<IntrospectionResponse?>?> map = <String, List<IntrospectionResponse>?>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic v) {
        map[key] = IntrospectionResponse.listFromJson(v, emptyIsNull: emptyIsNull, growable: growable);
      });
    }
    return map;
  }
}

